package sk.fiit.jim.agent.parsing;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.agent.models.FixedObject;
import sk.fiit.jim.agent.moves.Joint;
import sk.fiit.robocup.library.geometry.Vector3D;

/**
 *  ParsedData.java
 *  
 *  POJO holding data parsed from incoming message. Generated by {@link Parser}.
 *
 *@Title	Jim
 *@author	marosurbanec
 *@author	Androids
 */
public class ParsedData{
	/**
	 * The simulation time which is calculated since server starts.
	 */
	public double SIMULATION_TIME;
	/**
	 * The game time which is calculated when game is running, that
	 * means not in BEFORE_KICK_OFF game mode.
	 * 
	 */
	public double GAME_TIME;
	/**
	 * Player's id.
	 */
	public Integer PLAYER_ID;
	public Boolean OUR_SIDE_IS_LEFT; 
	public EnvironmentModel.PlayMode playMode;
	public Map<Joint, Double> agentsJoints = new HashMap<Joint, Double>();
	public Vector3D gyroscope;
	public Vector3D accelerometer;
	public ForceReceptor forceReceptor;
	
	public Vector3D ballRelativePosition;
	public Map<FixedObject, Vector3D> fixedObjects = new LinkedHashMap<FixedObject, Vector3D>();
	public List<PlayerData> otherplayers = new ArrayList<PlayerData>();
	
	public Boolean bumper;
	public HearReceptor hearReceptor;

}